#!/usr/bin/python3
import json
import util

class ClientHandler(util.MessageHandler):
    def __init__(self, reader, writer, SESSIONS):
        super().__init__(reader, writer, "[CLIENT]")
        self.SESSIONS = SESSIONS
        self.json_data = {}
        tmp = self.encryption_key
        self.encryption_key = self.decryption_key
        self.decryption_key = tmp

    async def make_request(self, payload, message_type):
        await self.send_message(message_type, payload)

        if not (await self.receive_message()):
            return False
        if not (await self.handle()):
            return False
        return True

    def parse_message(self, message_type):
        self.handler = None

        if self.session_id not in self.SESSIONS:
            if(message_type == 1):
                self.SESSIONS.append(self.session_id)
            else:
                raise util.ChallengeException("Invalid session ID")

        if message_type == 5:
            self.handler = self.launcherversion
        elif message_type in [2, 7, 8, 9]:
            self.handler = self.validate_json
        elif message_type not in [1, 2, 3, 4, 6]: # no response needed
            raise util.ChallengeException("Unknown message type")

    async def launcherversion(self, msg, session = None):
        try:
            x = msg.split(b".")
            for n in x:
                a = int(n)
        except:
            await self.send_message(0, "Unable to parse version string")
            return False
        return True

    async def validate_json(self, msg, session = None):
        try:
            self.json_data = json.loads(msg)
        except:
            await self.send_message(0, "Unable to parse JSON: " + str(msg))
            return False
        return True
