import util
import time
import base64
import hashlib

ACTIVATION_KEY = "PR2YU5CZGCYMS272GLZ1WA43W7P44I7S"
ACCOUNTS = {
    "godfather":    {"password":"TheLordWatchingYou",   "key":ACTIVATION_KEY},
    "julio_mafioso":{"password":"abc123",               "key":ACTIVATION_KEY},
    "test":         {"password":"test",                 "key":""},
    "antonio":      {"password":"G7Amj28mOwZ05Fnt2",    "key":ACTIVATION_KEY},
    "theviper":     {"password":";(bQ,*0.zW/y@g",       "key":""},
    "kenny":        {"password":"Hmmhmpf hmm hmmmpf",   "key":""},
    "trinity":      {"password":"D0dg3Th1s",            "key":ACTIVATION_KEY},
    "mario":        {"password":"Its@ME3ee",            "key":ACTIVATION_KEY},
    "rambro":       {"password":"_a863TC69lN5JaUd",     "key":""},
    "r2d2":         {"password":"not_a_bot",            "key":""},
}


def update_credential_hashes():
    for username in ACCOUNTS:
        b64username = base64.b64encode(username.encode())
        b64password = base64.b64encode(ACCOUNTS[username]["password"].encode())
        ACCOUNTS[username]["hashed"] = hashlib.sha256(b64username + b":" + b64password).hexdigest()

update_credential_hashes()


class Session():
    def __init__(self, session_id):
        self.state = "init"
        self.username = ""
        self.session_id = session_id
        self.last_access = int(time.time())

    def expired(self):
        if(int(time.time()) - self.last_access > 600):
            return True
        return False

    def check_state(self, desired_state):
        if(self.expired()):
            raise util.ChallengeException("Session expired")

        self.last_access = int(time.time())
        current_state = self.state
        if(desired_state == "disconnected"):
            if(current_state == "init"):
                raise util.ChallengeException("Initiate session with a 'hello' message")
        elif(desired_state == "connected"):
            if(current_state in ["disconnected", "init"]):
                raise util.ChallengeException("You must be connected to perform this action")
        elif(desired_state == "activated"):
            if(current_state != "activated"):
                raise util.ChallengeException("Your account must be activated to perform this action")

    def start(self):
        if(self.state == "init"):
            self.state = "disconnected"
        self.last_access = int(time.time())

    def connect(self, hashed):
        self.username = ""

        try:
            hashed = hashed.decode()
            for username in ACCOUNTS:
                if hashed != ACCOUNTS[username]["hashed"]:
                    continue

                self.username = username
                break
        except:
            pass

        if(self.username == ""):
            raise util.ChallengeException("Invalid credentials")

        if(ACCOUNTS[self.username]["key"] == ACTIVATION_KEY):
            self.state = "activated"
            activated = True
        else:
            self.state = "connected"
            activated = False

        return {"username":self.username, "activated":activated}

    def disconnect(self):
        self.username = ""
        self.state = "disconnected"

    def activate(self):
        self.state = "activated"
        ACCOUNTS[self.username]["key"] = ACTIVATION_KEY

    def dump_info(self, data):
        if "username" in data:
            data["username"] = self.username
        if "password" in data:
            data["password"] = ACCOUNTS[self.username]["password"]
        if "activation key" in data:
            if(self.state == "activated"):
                data["activation key"] = ACCOUNTS[self.username]["key"]
            else:
                data["activation key"] = "Account not activated"

        return data

    def update_password(self, new_password):
        ACCOUNTS[self.username]["password"] = new_password
        update_credential_hashes()

    def __str__(self):
        return self.session_id.hex() + ": " + self.username + " (" + self.state + ")"
